#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=lib\PasteColor.ico
#AutoIt3Wrapper_Outfile=..\PasteColor.exe
#AutoIt3Wrapper_Outfile_x64=..\PasteColorX64.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Compile_Both=y
#AutoIt3Wrapper_Res_Description=Copy paste tool for Windows color pickers
#AutoIt3Wrapper_Res_Fileversion=0.1.0.0
#AutoIt3Wrapper_Res_Icon_Add=lib\PasteColor-disabled.ico
#AutoIt3Wrapper_Res_Icon_Add=lib\PasteColor-alternate.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;~ #AutoIt3Wrapper_Res_Description=Copy paste tool for Windows color pickers
;~ #AutoIt3Wrapper_Res_Fileversion=0.1.0.0
;
;~ AutoIt Version: 3.0
;~ Language:       English
;~ Platform:       Win9x/NT
;~ Author:         Roland Toth (contact@rolandtoth.hu)
;~
;~ Script Function:
;~ Copy paste tool for Windows color pickers

#include <Array.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
#include <Misc.au3>
#Include <include\HotKey.au3>
#Include <include\HotKeyInput.au3>
#include <include\WinAPIEx.au3>

#Region Global Named HTML Color Variables ()
Global Const $cHTMLColorAliceBlue = "#F0F8FF", _
	$cHTMLColorAntiqueWhite = "#FAEBD7", _
	$cHTMLColorAqua = "#00FFFF", _
	$cHTMLColorAquamarine = "#7FFFD4", _
	$cHTMLColorAzure = "#F0FFFF", _
	$cHTMLColorBeige = "#F5F5DC", _
	$cHTMLColorBisque = "#FFE4C4", _
	$cHTMLColorBlack = "#000000", _
	$cHTMLColorBlanchedAlmond = "#FFEBCD", _
	$cHTMLColorBlue = "#0000FF", _
	$cHTMLColorBlueViolet = "#8A2BE2", _
	$cHTMLColorBrown = "#A52A2A", _
	$cHTMLColorBurlyWood = "#DEB887", _
	$cHTMLColorCadetBlue = "#5F9EA0", _
	$cHTMLColorChartreuse = "#7FFF00", _
	$cHTMLColorChocolate = "#D2691E", _
	$cHTMLColorCoral = "#FF7F50", _
	$cHTMLColorCornflowerBlue = "#6495ED", _
	$cHTMLColorCornsilk = "#FFF8DC", _
	$cHTMLColorCrimson = "#DC143C", _
	$cHTMLColorCyan = "#00FFFF", _
	$cHTMLColorDarkBlue = "#00008B", _
	$cHTMLColorDarkCyan = "#008B8B", _
	$cHTMLColorDarkGoldenRod = "#B8860B", _
	$cHTMLColorDarkGray = "#A9A9A9", _
	$cHTMLColorDarkGrey = "#A9A9A9", _
	$cHTMLColorDarkGreen = "#006400", _
	$cHTMLColorDarkKhaki = "#BDB76B", _
	$cHTMLColorDarkMagenta = "#8B008B", _
	$cHTMLColorDarkOliveGreen = "#556B2F", _
	$cHTMLColorDarkorange = "#FF8C00", _
	$cHTMLColorDarkOrchid = "#9932CC", _
	$cHTMLColorDarkRed = "#8B0000", _
	$cHTMLColorDarkSalmon = "#E9967A", _
	$cHTMLColorDarkSeaGreen = "#8FBC8F", _
	$cHTMLColorDarkSlateBlue = "#483D8B", _
	$cHTMLColorDarkSlateGray = "#2F4F4F", _
	$cHTMLColorDarkSlateGrey = "#2F4F4F", _
	$cHTMLColorDarkTurquoise = "#00CED1", _
	$cHTMLColorDarkViolet = "#9400D3", _
	$cHTMLColorDeepPink = "#FF1493", _
	$cHTMLColorDeepSkyBlue = "#00BFFF", _
	$cHTMLColorDimGray = "#696969", _
	$cHTMLColorDimGrey = "#696969", _
	$cHTMLColorDodgerBlue = "#1E90FF", _
	$cHTMLColorFireBrick = "#B22222", _
	$cHTMLColorFloralWhite = "#FFFAF0", _
	$cHTMLColorForestGreen = "#228B22", _
	$cHTMLColorFuchsia = "#FF00FF", _
	$cHTMLColorGainsboro = "#DCDCDC", _
	$cHTMLColorGhostWhite = "#F8F8FF", _
	$cHTMLColorGold = "#FFD700", _
	$cHTMLColorGoldenRod = "#DAA520", _
	$cHTMLColorGray = "#808080", _
	$cHTMLColorGrey = "#808080", _
	$cHTMLColorGreen = "#008000", _
	$cHTMLColorGreenYellow = "#ADFF2F", _
	$cHTMLColorHoneyDew = "#F0FFF0", _
	$cHTMLColorHotPink = "#FF69B4", _
	$cHTMLColorIndianRed = "#CD5C5C", _
	$cHTMLColorIndigo = "#4B0082", _
	$cHTMLColorIvory = "#FFFFF0", _
	$cHTMLColorKhaki = "#F0E68C", _
	$cHTMLColorLavender = "#E6E6FA", _
	$cHTMLColorLavenderBlush = "#FFF0F5", _
	$cHTMLColorLawnGreen = "#7CFC00", _
	$cHTMLColorLemonChiffon = "#FFFACD", _
	$cHTMLColorLightBlue = "#ADD8E6", _
	$cHTMLColorLightCoral = "#F08080", _
	$cHTMLColorLightCyan = "#E0FFFF", _
	$cHTMLColorLightGoldenRodYellow = "#FAFAD2", _
	$cHTMLColorLightGray = "#D3D3D3", _
	$cHTMLColorLightGrey = "#D3D3D3", _
	$cHTMLColorLightGreen = "#90EE90", _
	$cHTMLColorLightPink = "#FFB6C1", _
	$cHTMLColorLightSalmon = "#FFA07A", _
	$cHTMLColorLightSeaGreen = "#20B2AA", _
	$cHTMLColorLightSkyBlue = "#87CEFA", _
	$cHTMLColorLightSlateGray = "#778899", _
	$cHTMLColorLightSlateGrey = "#778899", _
	$cHTMLColorLightSteelBlue = "#B0C4DE", _
	$cHTMLColorLightYellow = "#FFFFE0", _
	$cHTMLColorLime = "#00FF00", _
	$cHTMLColorLimeGreen = "#32CD32", _
	$cHTMLColorLinen = "#FAF0E6", _
	$cHTMLColorMagenta = "#FF00FF", _
	$cHTMLColorMaroon = "#800000", _
	$cHTMLColorMediumAquaMarine = "#66CDAA", _
	$cHTMLColorMediumBlue = "#0000CD", _
	$cHTMLColorMediumOrchid = "#BA55D3", _
	$cHTMLColorMediumPurple = "#9370DB", _
	$cHTMLColorMediumSeaGreen = "#3CB371", _
	$cHTMLColorMediumSlateBlue = "#7B68EE", _
	$cHTMLColorMediumSpringGreen = "#00FA9A", _
	$cHTMLColorMediumTurquoise = "#48D1CC", _
	$cHTMLColorMediumVioletRed = "#C71585", _
	$cHTMLColorMidnightBlue = "#191970", _
	$cHTMLColorMintCream = "#F5FFFA", _
	$cHTMLColorMistyRose = "#FFE4E1", _
	$cHTMLColorMoccasin = "#FFE4B5", _
	$cHTMLColorNavajoWhite = "#FFDEAD", _
	$cHTMLColorNavy = "#000080", _
	$cHTMLColorOldLace = "#FDF5E6", _
	$cHTMLColorOlive = "#808000", _
	$cHTMLColorOliveDrab = "#6B8E23", _
	$cHTMLColorOrange = "#FFA500", _
	$cHTMLColorOrangeRed = "#FF4500", _
	$cHTMLColorOrchid = "#DA70D6", _
	$cHTMLColorPaleGoldenRod = "#EEE8AA", _
	$cHTMLColorPaleGreen = "#98FB98", _
	$cHTMLColorPaleTurquoise = "#AFEEEE", _
	$cHTMLColorPaleVioletRed = "#DB7093", _
	$cHTMLColorPapayaWhip = "#FFEFD5", _
	$cHTMLColorPeachPuff = "#FFDAB9", _
	$cHTMLColorPeru = "#CD853F", _
	$cHTMLColorPink = "#FFC0CB", _
	$cHTMLColorPlum = "#DDA0DD", _
	$cHTMLColorPowderBlue = "#B0E0E6", _
	$cHTMLColorPurple = "#800080", _
	$cHTMLColorRed = "#FF0000", _
	$cHTMLColorRosyBrown = "#BC8F8F", _
	$cHTMLColorRoyalBlue = "#4169E1", _
	$cHTMLColorSaddleBrown = "#8B4513", _
	$cHTMLColorSalmon = "#FA8072", _
	$cHTMLColorSandyBrown = "#F4A460", _
	$cHTMLColorSeaGreen = "#2E8B57", _
	$cHTMLColorSeaShell = "#FFF5EE", _
	$cHTMLColorSienna = "#A0522D", _
	$cHTMLColorSilver = "#C0C0C0", _
	$cHTMLColorSkyBlue = "#87CEEB", _
	$cHTMLColorSlateBlue = "#6A5ACD", _
	$cHTMLColorSlateGray = "#708090", _
	$cHTMLColorSlateGrey = "#708090", _
	$cHTMLColorSnow = "#FFFAFA", _
	$cHTMLColorSpringGreen = "#00FF7F", _
	$cHTMLColorSteelBlue = "#4682B4", _
	$cHTMLColorTan = "#D2B48C", _
	$cHTMLColorTeal = "#008080", _
	$cHTMLColorThistle = "#D8BFD8", _
	$cHTMLColorTomato = "#FF6347", _
	$cHTMLColorTurquoise = "#40E0D0", _
	$cHTMLColorViolet = "#EE82EE", _
	$cHTMLColorWheat = "#F5DEB3", _
	$cHTMLColorWhite = "#FFFFFF", _
	$cHTMLColorWhiteSmoke = "#F5F5F5", _
	$cHTMLColorYellow = "#FFFF00", _
	$cHTMLColorYellowGreen = "#9ACD32"
#EndRegion Global Named HTML Color Variables

#Region Globals
Global $sName = "PasteColor", $sVersion = "v0.1", $hPasteColorInput, $sColor, $r, $g, $b, $aArray, $sUserInput, $sLastColor, $hAboutGUI, _
	$sNamedColor, $iCounter = 0, $nAlternateSendMethod = 0, $nEnabled, $hNoGUI, _
	$bForceAlternateSendMethod, $iSendDelay, $bShowTrayIcon, $bShowTrayNotifications, $bNoValidation, _
	$hTraySettings, $hTrayHelp, $hTrayAbout, $bTrayEnabled, $hTrayExit, $hPasteColorSettings, $hBtnOK, $hBtnCancel, $hNotifications, _
	$hTrayicon, $hForceAlternateSendMethod, $hNoValidation, $hHotkey, $hBtnAbout, _
	$hActiveWindow, $hActiveHandle, $hActiveClassName, $hActiveClass, $hActiveInstance
#EndRegion Globals

Init()
Tray()
GUI()
LoadSettings()
MainLoop()

Func Init()
	Opt("GUIOnEventMode", 1)
	Opt("GUICloseOnESC", 1)
	Opt("TrayOnEventMode", 1)
	Opt("TrayMenuMode", 3)

	If _Singleton($sName, 1) = 0 Then
		Send("#^+!p")
		Terminate()
	Else
		HotKeySet("#^+!p", "ShowSettings")
    EndIf

	$hNoGUI = GUICreate("")
	GUISetIcon(@ScriptFullPath, 0)

	; Lock CTRL-ALT-DEL for Hotkey Input control, but not for Windows
	_KeyLock(0x062E)
EndFunc;==> Init()

Func Tray()
	TraySetClick(16)	; context menu only on tray icon right-click

	$hTraySettings = TrayCreateItem("Settings")
	$hTrayHelp = TrayCreateItem("Help")
	$hTrayAbout = TrayCreateItem("About")
	TrayCreateItem("")
	$bTrayEnabled = TrayCreateItem("Enabled")
	TrayCreateItem("")
	$hTrayExit = TrayCreateItem("Exit")

	TrayItemSetOnEvent($hTraySettings, "ShowSettings")
	TrayItemSetOnEvent($hTrayAbout, "ShowAbout")
	TrayItemSetOnEvent($hTrayHelp, "ShowHelp")
	TrayItemSetOnEvent($bTrayEnabled, "ToggleEnabled")
	TrayItemSetOnEvent($hTrayExit, "Terminate")

	TraySetOnEvent($TRAY_EVENT_PRIMARYDOUBLE, "ShowSettings")

	If IniRead("Settings.ini", "SETTINGS", "ShowTrayIcon", 1) = 1 Then
		TraySetState()
	Else
		TraySetState(2)
	EndIf
EndFunc;==> Tray()

Func GUI()
	Local $GUIWidth = 321, $GUIHeight = 281
	Local $posX = (@DesktopWidth - $GUIWidth) / 2
	Local $posY = (@DesktopHeight - $GUIHeight) / 2 - 40

	$hPasteColorSettings = GUICreate($sName & " settings", $GUIWidth, $GUIHeight, $posX, $posY, BitXOR($GUI_SS_DEFAULT_GUI, $WS_MINIMIZEBOX), $WS_EX_TOPMOST)
	GUISetIcon(@ScriptFullPath,0)
	$hBtnOK = GUICtrlCreateButton("OK", 24, 240, 75, 25)
	$hBtnCancel = GUICtrlCreateButton("Cancel", 110, 240, 75, 25)
	GUICtrlCreateGroup("General", 24, 16, 273, 106)
	$hNotifications = GUICtrlCreateCheckbox("Enable notifications", 40, 40, 185, 17)
	GUICtrlSetTip(-1, "Show notification tooltips when copying a color")
	$hTrayicon = GUICtrlCreateCheckbox("Show tray icon", 40, 64, 97, 17)
	GUICtrlSetTip(-1, "Uncheck to hide " & $sName & " system tray icon")
	$iSendDelay = GUICtrlCreateInput("", 104, 90, 50, 21)
	GUICtrlSetLimit(-1, 4)
	GUICtrlSetTip(-1, "milliseconds between sending values")
	GUICtrlSetCursor (-1, 5)
	GUICtrlCreateLabel("Send delay:", 40, 93, 60, 17)
	GUICtrlCreateLabel("milliseconds", 160, 93, 60, 17)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup("Advanced", 24, 130, 273, 100)
	$hForceAlternateSendMethod = GUICtrlCreateCheckbox("Force alternative send method", 40, 152, 225, 17)
	GUICtrlSetTip(-1, "Check to always use the alternative send method" & @CRLF & "(better compability)")
	$hNoValidation = GUICtrlCreateCheckbox("Disable validation", 40, 174, 185, 17)
	GUICtrlSetTip(-1, "Bypass color validation")
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateLabel('Hotkey:', 40, 203, 54, 17)
	$hHotkey = _GUICtrlHKI_Create(0, 84, 200, 120, 20)
	GUICtrlSetTip(-1, "Click to set " & $sName & " hotkey")
	GUISetState(@SW_HIDE, $hPasteColorSettings)

	GUICtrlSetOnEvent($hBtnOK, "SaveSettings")
	GUICtrlSetOnEvent($hBtnCancel, "LoadSettings")
	GUISetOnEvent($GUI_EVENT_CLOSE, "LoadSettings")
EndFunc;==> GUI()

Func MainLoop()
	While 1
		Sleep(5000)
		_WinAPI_EmptyWorkingSet()
	WEnd
EndFunc;==> MainLoop()

Func ShowAbout()
	If Not WinActive($hPasteColorSettings) Then
		$hAboutGUI = GUICreate("About " & $sName, 270, 138, Default, Default, BitXOR($GUI_SS_DEFAULT_GUI, $WS_MINIMIZEBOX), $WS_EX_TOPMOST)
		GUISetIcon(@ScriptFullPath, 0)
		GUISetFont(9, 400)

		GUICtrlCreateLabel($sName & " " & $sVersion, 21, 18, 232)
		GUICtrlSetFont(-1, 9.5, 700)

		GUICtrlCreateLabel("Copy paste tool for Windows color pickers", 20, 42, 232)
		GUICtrlSetFont(-1, 8.5)

		$url = GUICtrlCreateLabel(" 2013 rolandtoth.hu", 20, 66, 104, 15)
		GUICtrlSetCursor(-1, 0)

		GUICtrlSetFont(-1, 8.5, Default, 2)

		$hBtnAbout = GUICtrlCreateButton("OK", 20, 96, 78, 25)
		GUISetState(@SW_SHOW, $hAboutGUI)

		GUICtrlSetOnEvent($url, "OpenURL")
		GUICtrlSetOnEvent($hBtnAbout, "CloseWindow")
		GUISetOnEvent($GUI_EVENT_CLOSE, "CloseWindow")
	Else
		WinActivate($hPasteColorSettings)
	EndIf
EndFunc;==> ShowAbout()

Func ShowHelp()
	If FileExists(@ScriptDir & "/Readme.txt") Then
		ShellExecute(@ScriptDir & "/Readme.txt")
	Else
		Msgbox(0 + 32 + 262144, $sName, $sName & " readme file is not available!", 0, $hNoGUI)
	EndIf
EndFunc;==> ShowHelp()

Func CloseWindow()
	GUISetState(@SW_HIDE, @GUI_WINHANDLE)
EndFunc;==> On_Close()

Func OpenURL()
	ShellExecute("http://rolandtoth.hu/")
	GUISetState(@SW_HIDE, $hAboutGUI)
 EndFunc;==> OpenURL()

Func ShowSettings()
	If $nEnabled = 1 Then
		WinSetTitle($hPasteColorSettings, "", $sName & " settings")
	Else
		WinSetTitle($hPasteColorSettings, "", $sName & " settings (currently disabled)")
	EndIf

	If WinGetState($hPasteColorSettings) = 5 Then
		GUISetState(@SW_SHOW, $hPasteColorSettings)
	Else
		WinActivate($hPasteColorSettings)
;~ 		WinFlash($hPasteColorInput, "", 3, 300)
	EndIf
EndFunc;==> ShowSettings()

Func LoadSettings()
	GUISetState(@SW_HIDE, $hPasteColorSettings)

	If Not $sNamedColor = "" Then
		$sColor = $sNamedColor
	ElseIf Not $sLastColor = "" Then
		$sColor = $sLastColor
	ElseIf Not $sUserInput = "last" Then
		$sColor = $sUserInput
	Else
		$sUserInput = ClipGet()
		$sColor = ClipGet()
	EndIf

	$sNamedColor = ""
	$sLastColor = ""

	$bForceAlternateSendMethod = IniRead("Settings.ini", "SETTINGS", "ForceAlternateSendMethod", 0)
	If $bForceAlternateSendMethod = 1 Then
		GUICtrlSetState($hForceAlternateSendMethod, $GUI_CHECKED)
	Else
		GUICtrlSetState($hForceAlternateSendMethod, $GUI_UNCHECKED)
	EndIf

	$nEnabled = IniRead("Settings.ini", "SETTINGS", "Enabled", 1)
	If $nEnabled = 1 Then
		If $bForceAlternateSendMethod = 1 Then
			TraySetIcon(@ScriptFullPath, -6)
		Else
			TraySetIcon(@ScriptFullPath, 0)
		EndIf
		TrayItemSetText ($bTrayEnabled, "Enabled")
		TrayItemSetState ($bTrayEnabled, $TRAY_CHECKED)
	Else
		_Hotkey_Release($HK_FLAG_NOERROR)
		TraySetToolTip($sName & @CRLF & "(disabled)")
		TraySetIcon(@ScriptFullPath, -5)
		TrayItemSetText ($bTrayEnabled, "Enable")
		TrayItemSetState ($bTrayEnabled, $TRAY_UNCHECKED)
	EndIf

	$bShowTrayIcon = IniRead("Settings.ini", "SETTINGS", "ShowTrayIcon", 1)
	If $bShowTrayIcon = 1 Then
		GUICtrlSetState($hTrayicon, $GUI_CHECKED)
		TraySetState()
	Else
		TraySetState(2)
		GUICtrlSetState($hTrayicon, $GUI_UNCHECKED)
	EndIf

	$bShowTrayNotifications = IniRead("Settings.ini", "SETTINGS", "ShowTrayNotifications", 1)
	If $bShowTrayNotifications = 1 Then
		GUICtrlSetState($hNotifications, $GUI_CHECKED)
	Else
		GUICtrlSetState($hNotifications, $GUI_UNCHECKED)
	EndIf

	$bNoValidation = IniRead("Settings.ini", "SETTINGS", "NoValidation", 0)
	If $bNoValidation = 1 Then
		GUICtrlSetState($hNoValidation, $GUI_CHECKED)
	Else
		GUICtrlSetState($hNoValidation, $GUI_UNCHECKED)
	EndIf

	$iSendDelay = IniRead("Settings.ini", "SETTINGS", "SendDelay", 0)
	If $iSendDelay >= 0 Then
		GUICtrlSetData($iSendDelay, $iSendDelay, "")
	EndIf

	Local $Hotkey = IniRead("Settings.ini", "SETTINGS", "Hotkey", 0x0350)
	_Hotkey_Release($HK_FLAG_NOERROR)
	_HotKey_Assign($Hotkey, "PasteColorMain", $HK_FLAG_NOERROR)
	_GUICtrlHKI_SetHotKey($hHotkey, $Hotkey)

	TraySetToolTip($sName & @CRLF & "Hotkey: " & _KeyToStr($Hotkey))

	If $nEnabled = 0 Then
		TraySetToolTip($sName & @CRLF & "(disabled)")
		_Hotkey_Release($HK_FLAG_NOERROR)
	EndIf

	Local $iniSectionNames = IniReadSectionNames("Settings.ini")
	If Not @error = 1 Then
		If $iniSectionNames[0] > 0 Then	; at least one ini section exists
		Local $iniKeys = 0
			For $i = 1 To $iniSectionNames[0] Step 1
				Local $iniSections = IniReadSection ("Settings.ini", $iniSectionNames[$i])
				If Not @error = 1 Then
					$iniKeys += $iniSections[0][0]
				EndIf
			Next
			If $iniKeys = 0 Then
				FileDelete("Settings.ini")
			EndIf
		EndIf
	EndIf
EndFunc;==> LoadSettings()

Func SaveSettings()
	; save user choices to ini file
	If GUICtrlRead($hForceAlternateSendMethod) = 1 Then
		IniWrite("Settings.ini", "SETTINGS", "ForceAlternateSendMethod", 1)
	Else
		IniDelete("Settings.ini", "SETTINGS", "ForceAlternateSendMethod")
	EndIf

	If GUICtrlRead($hTrayicon) = 1 Then
		IniDelete("Settings.ini", "SETTINGS", "ShowTrayIcon")
	Else
		IniWrite("Settings.ini", "SETTINGS", "ShowTrayIcon", 0)
	EndIf

	If GUICtrlRead($hNotifications) = 1 Then
		IniDelete("Settings.ini", "SETTINGS", "ShowTrayNotifications")
	Else
		IniWrite("Settings.ini", "SETTINGS", "ShowTrayNotifications", 0)
	EndIf

	If GUICtrlRead($hNoValidation) = 1 Then
		IniWrite("Settings.ini", "SETTINGS", "NoValidation", 1)
	Else
		IniDelete("Settings.ini", "SETTINGS", "NoValidation")
	EndIf

	If Not GUICtrlRead($iSendDelay) = 0 Then
		$iSendDelay = GUICtrlRead($iSendDelay)

		If($iSendDelay) > 0 Then
			IniWrite("Settings.ini", "SETTINGS", "SendDelay", $iSendDelay)
		Else
			IniDelete("Settings.ini", "SETTINGS", "SendDelay")
		EndIf
	EndIf

	Local $Hotkey = _GUICtrlHKI_GetHotKey($hHotkey)
	If Not $Hotkey = 0 Then
		$Hotkey = "0x" & StringRight(Hex(_GUICtrlHKI_GetHotKey($hHotkey)), 4)
		If $Hotkey = 0x0350 Then
			IniDelete("Settings.ini", "SETTINGS", "Hotkey")
		Else
			IniWrite("Settings.ini", "SETTINGS", "Hotkey", $Hotkey)
		EndIf
	EndIf

	LoadSettings()
EndFunc;==> SaveSettings()

Func ToggleEnabled()
	If $nEnabled = 1 Then
		IniWrite("Settings.ini", "SETTINGS", "Enabled", 0)
	Else
		IniDelete("Settings.ini", "SETTINGS", "Enabled")
	EndIf

	LoadSettings()
EndFunc;==> ToggleEnabled()

Func GetHandles()
    $hActiveWindow = WinGetTitle("")
    $hActiveHandle = ControlGetHandle($hActiveWindow, "", ControlGetFocus($hActiveWindow))
    $hActiveClassName = _ControlGetClassnameNN($hActiveHandle)
    $hActiveClass = _WinAPI_GetClassName($hActiveHandle)
    $hActiveInstance = StringTrimLeft ($hActiveClassName, StringLen($hActiveClass))

	$nAlternateSendMethod = 0
	If ($bForceAlternateSendMethod = 1 OR $hActiveInstance = "") Then $nAlternateSendMethod = 1
EndFunc;==> GetHandles()

Func PasteColorMain()
	LoadSettings()
	GetHandles()
    Main()
	If $sColor = "settings" Then
		ShowSettings()
		Return
	EndIf
		PasteColor($r, $g, $b)
		MainLoop()
EndFunc;==> PastecolorMain()

Func Main()
;~ 	GUISetState(@SW_HIDE, $hAboutGUI)
	If WinGetState($hPasteColorInput) = 1 Then Return
;~ 	If WinGetState($hPasteColorSettings) = 5 Then
;~ 		MainLoop()
;~ 		Return
;~ 	EndIf
    GetInput($sColor)
	If $sColor = "settings" Then Return
	CleanInput($sColor)
	ValidateInput($sColor)
EndFunc;==> Main()

Func ShowError()
	$hNoGUI = GUICreate("")
	GUISetIcon(@ScriptFullPath,0)
    If Msgbox(5 + 16 + 262144, $sName & " error", "Invalid color!", 0, $hNoGUI) = 2 Then
        MainLoop()
    Else
        SetFocus()
        Main()
    EndIf
EndFunc;==> ShowError()

Func SetFocus()
    If Not WinActive($hActiveWindow) Then WinActivate($hActiveWindow)
    If Not $nAlternateSendMethod = 1 Then
		If ControlFocus($hActiveWindow, "", $hActiveHandle) = 0 Then
			Msgbox(0 + 16 + 262144, $sName & " error", "Cannot find active window!", 0, $hNoGUI)
			MainLoop()
		EndIf
    EndIf
EndFunc;==> SetFocus()

Func NextControl()
	If $nAlternateSendMethod = 1 Then
		Send("{TAB}")
		Sleep($iSendDelay)
		$iCounter += 1
	Else
        $hActiveInstance += 1
        ControlFocus($hActiveWindow, "", "[CLASS:" & $hActiveClass & "; INSTANCE:" & $hActiveInstance & "]")
		Sleep($iSendDelay)
	EndIf
EndFunc;==>NextControl()

Func _ControlGetClassnameNN($hControl)
    If Not IsHWnd($hControl) Then Return SetError(1, 0, "")
    Local Const $hParent = _WinAPI_GetParent($hControl)
    If Not $hParent Then Return SetError(2, 0, "")
    Local Const $sList = WinGetClassList($hParent)
    Local $aList = StringSplit(StringTrimRight($sList, 1), @LF, 2)
    _ArraySort($aList)
     Local $nInstance, $sLastClass, $sComposite
     For $i = 0 To UBound($aList) - 1
         If $sLastClass <> $aList[$i] Then
            $sLastClass = $aList[$i]
            $nInstance = 1
        EndIf
        $sComposite = $sLastClass & $nInstance
        If ControlGetHandle($hParent, "", $sComposite) = $hControl Then Return $sComposite
        $nInstance += 1
    Next
    Return SetError(3, 0, "")
EndFunc;==> _ControlGetClassnameNN()

Func GetText($handle)
	If $nAlternateSendMethod = 1 Then
		Send("{TAB}")
		Send("+{TAB}")
		If ControlGetText($hActiveWindow, "", "") = 0 Then
			Send("^c")
			Return ClipGet()
		Else
			Return ControlGetText($hActiveWindow, "", "")
		EndIf
	Else
		Return ControlGetText($hActiveWindow, "", $handle)
	EndIf
EndFunc;==> GetText()

Func ShowTrayNotifications($text, $timeout)
	If $bShowTrayNotifications = 1 Then
		TrayTip($sName, $text, $timeout, 1)
	EndIf
EndFunc;==> ShowTrayNotification()

Func CopyX($repeat)
    If $repeat > 6 AND Msgbox(4 + 32 + 262144, $sName, "You are about to copy " & $repeat & " items." & @CRLF & @CRLF & "Continue?", 0, $hNoGUI) = 7 Then MainLoop()

    SetFocus()

    Local $aArray[$repeat]

    $aArray[0] = GetText($hActiveHandle)

    For $count = 1 To $repeat - 1
        NextControl()
        $aArray[$count] = GetText("")
    Next

	Local $sColor = _ArrayToString($aArray, ",")
    ClipPut ($sColor)

	SaveLastColor()

	ShowTrayNotifications('Color copied: ' & $sColor, 6000)

    SetFocus()

	FocusOriginalControl()

    MainLoop()
EndFunc;==> CopyX()

Func PasteX($input)
	SaveLastColor()

    $input = StringStripWS($input, 1)

    If (Not StringInStr( $input, ',') OR $input = "paste") Then
		$aArray = StringSplit(ClipGet(), ",")
    Else
       $aArray = StringSplit($input, ",")
    EndIf

    If $aArray[0] > 6 AND Msgbox(4 + 32 + 262144, $sName, "You are about to paste " & $aArray[0] & " items." & @CRLF & @CRLF & "Continue?", 0, $hNoGUI) = 7 Then MainLoop()

    SetFocus()

    ControlSetText($hActiveWindow, "", $hActiveHandle, $aArray[1])

    For $count = 2 To $aArray[0]
        NextControl()
        ControlSetText($hActiveWindow, "", "", StringStripWS($aArray[$count], 1))
    Next

    SetFocus()
	FocusOriginalControl()

	TrayTip ( "", "", 1)
    MainLoop()
EndFunc;==> PasteX()

Func CopyColor()
    SetFocus()

    $r = GetText($hActiveHandle)
    NextControl()

    $g = GetText("")
    NextControl()

    $b = GetText("")

    If $sColor = "copy" OR $sColor = "rgb" Then
        $sColor = $r & "," & $g & "," & $b
    ElseIf $sColor = "hex" Then
        RGBtoHex("", $r, $g, $b)
    ElseIf $sColor = "hexx" Then
        RGBtoHex("#", $r, $g, $b)
    EndIf

	SaveLastColor()

    ClipPut($sColor)

	TrayTip ( "", "", 1)
	ShowTrayNotifications( 'Color copied: ' & $sColor, 6000 )

    SetFocus()

	FocusOriginalControl()

	MainLoop()
EndFunc;==> CopyColor()

Func RGBtoHex($prefix, $r, $g, $b)
    $sColor = $prefix & Hex($r, 2) & Hex($g, 2) & Hex($b, 2);
EndFunc;==> RGBtoHex()

Func FocusOriginalControl()
    If $nAlternateSendMethod = 1 Then
		Send("+{TAB " & $iCounter & "}")
		Send("{LEFT}")
		$iCounter = 0
	EndIf
EndFunc;==> FocusOriginalControl()

Func SixDigitColor($var)
    $aArray = StringSplit($var, "");
    $sColor = ""

    For $count = 1 To StringLen($var)
        $sColor &= $aArray[$count] & $aArray[$count]
    Next
EndFunc;==> SixDigitColor()

Func SaveLastColor()
	If $sColor = "last" Or $sColor = "settings" Or $sColor = "exit" Then
		Return
	EndIf

	Local $saveColor = ""

	If Not $sNamedColor = "" Then
		$saveColor = $sNamedColor
	ElseIf Not $sLastColor = "" Then
		$saveColor = $sLastColor
	Else
		$saveColor = $sColor
	EndIf

	IniWrite("Settings.ini", "SETTINGS", "LastColor", $saveColor)
EndFunc;==> SaveLastColor()

Func SplitRGB($var)
    $aArray = StringSplit($var, ",");
    $r = $aArray[1] + 0   ; remove leading zeros
    $g = $aArray[2] + 0
    $b = $aArray[3] + 0
 EndFunc;==> SplitRGB()

Func HexToRGB($var)
    $var = "0x" & $var
    $r = BitAND(BitShift($var, 16), 0xFF)
    $g = BitAND(BitShift($var, 8), 0xFF)
    $b = BitAND($var, 0xFF)
EndFunc;==> HexToRGB()

Func PasteColor($r, $g, $b)
	$sLastColor = $sUserInput
	SaveLastColor()

	SetFocus()

	If $nAlternateSendMethod = 1 Then
		Send("{TAB}")
		Send("+{TAB}")
		ControlSend($hActiveWindow, "", "", $r)
		NextControl()
		ControlSend($hActiveWindow, "", "", $g)
		NextControl()
		ControlSend($hActiveWindow, "", "", $b)
	Else
		ControlSetText($hActiveWindow, "", $hActiveHandle, $r)
		NextControl()
		ControlSetText($hActiveWindow, "", "", $g)
		NextControl()
		ControlSetText($hActiveWindow, "", "", $b)
	EndIf
    SetFocus()

	FocusOriginalControl()
	Send("{LEFT}")
	Send("{RIGHT}")

	MainLoop()
EndFunc;==> PasteColor()

Func ValidateInput($var)
	If $bNoValidation = 1 Then
		Return
	EndIf

    If StringRegExp($var, '\b((0x0|0x00){1})?([0-9a-fA-F]){6}\b|^(0*([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])[, \s]\s*){2}(0*([01]?[0-9]?[0-9]|2[0-4][0-9]|25[0-5])([,]{1})?)\s*$', 0) = 0 Then
        ShowError()
        Return
    EndIf

    ; convert color to Hex or RGB
    If StringInStr($var, ",") > 0 Then
        SplitRGB($var)
    Else
        HexToRGB($var)
    EndIf
EndFunc;==> ValidateInput()

Func CleanInput($var)
    $var = StringStripWS($var, 1)
    $var = StringStripWS($var, 2)

    If StringLeft($var, 1) = "#" Then
        $var = StringTrimLeft($var, 1)
    EndIf

    $var = StringReplace($var, " ", ",")
    $var = StringReplace($var, ",,", ",")
    $sColor = StringReplace($var, ",,", ",")

    If StringLen($sColor) = 3 AND StringInStr($sColor, ",") = 0 AND StringIsXDigit($sColor) Then
        SixDigitColor($sColor)
    EndIf
EndFunc;==> CleanInput()

Func GetInput($var)
	TrayTip ( "", "", 1)

	$hPasteColorInput = GUICreate("")
	WinSetOnTop($hPasteColorInput, "", 1)
	GUISetState(@SW_HIDE, $hPasteColorInput)

	WinActivate($hPasteColorInput)

	$sColor = InputBox($sName, "Enter color:", StringLeft($var, 100), " M100", Default, 132, Default, Default, Default, $hPasteColorInput)

	If Not @Error = 0 Then MainLoop()

	If Not $sLastColor = "" Then
		$sUserInput = $sLastColor
	Else
		$sUserInput = $sColor
	EndIf

	If $sColor = "exit" Then Terminate()

	If $sColor = "last" Then
		$sColor = IniRead("Settings.ini", "SETTINGS", "LastColor", -1)
		If $sColor = -1 Or $sColor = "" Then
			Msgbox(0 + 64 + 262144, $sName, "No last color is available!", 0, $hNoGUI)
			$sColor = ""
			Main()
		EndIf
    EndIf

	; check if userinput is a named html color
	If IsDeclared("cHTMLColor" & $sColor) Then
		$sColor = Eval("cHTMLColor" & $sColor)
		$sNamedColor = $sUserInput
	EndIf

	; check if userinput is a user defined color
	Local $tmpColor = IniRead("Settings.ini", "USERCOLOR", $sColor, "")
	If Not $tmpColor = "" Then
		$sColor = $tmpColor
	EndIf

	If $sColor = "settings" Then
		ShowSettings()
        Return
    EndIf

    If $sColor = "copy" OR $sColor = "rgb" OR $sColor = "hex" OR $sColor = "hexx" Then
        CopyColor()
        Return
    EndIf

    If StringLeft($sColor, 1) = "c" AND StringIsDigit(StringTrimLeft($sColor, 1)) AND StringTrimLeft($sColor, 1) > 0 Then
        CopyX(StringTrimLeft($sColor, 1))
        Return
    EndIf

    If $sColor = "paste" Then
        $sColor = ClipGet()
        $sUserInput = $sColor
        CleanInput($sColor)
        ValidateInput($sColor)
        PasteColor($r, $g, $b)
        Return
    EndIf

    If StringLeft($sColor, 1) = "p" Then
        PasteX(StringTrimLeft($sColor, 1))
        Return
    EndIf
EndFunc;==> GetInput()

Func Terminate()
	Exit 0
EndFunc;==> Terminate()